import 'package:flutter/widgets.dart';
import 'package:leancode_common/leancode_common.dart';

class Disposer<T extends Disposable> extends StatefulWidget {
  const Disposer({
    @required this.model,
    this.child,
    Key key,
  })  : assert(model != null),
        super(key: key);

  final T model;
  final Widget child;

  @override
  _DisposerState createState() => _DisposerState(model);
}

class _DisposerState extends State<Disposer> {
  _DisposerState(this._model);

  Disposable _model;

  void _dispose() {
    _model.dispose();
  }

  @override
  void didUpdateWidget(Disposer<Disposable> oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (oldWidget.model != widget.model) {
      _dispose();
      _model = widget.model;
    }
  }

  @override
  Widget build(BuildContext context) => widget.child;

  @override
  void dispose() {
    super.dispose();
    _dispose();
  }
}
