import 'package:flutter/widgets.dart';
import 'package:leancode_common/leancode_common.dart';

class Initializer<T extends Initializable> extends StatefulWidget {
  const Initializer({
    @required this.model,
    this.child,
    Key key,
  })  : assert(model != null),
        super(key: key);

  final T model;
  final Widget child;

  @override
  _InitializerState createState() => _InitializerState(model);
}

class _InitializerState extends State<Initializer> {
  _InitializerState(this._model);

  Initializable _model;

  void _init() {
    _model.initialize();
  }

  @override
  void initState() {
    super.initState();
    _init();
  }

  @override
  void didUpdateWidget(Initializer<Initializable> oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (oldWidget.model != widget.model) {
      _model = widget.model;
      _init();
    }
  }

  @override
  Widget build(BuildContext context) => widget.child;
}
