import 'package:async/async.dart';
import 'package:flutter/widgets.dart';
import 'package:leancode_common/leancode_common.dart';

@deprecated
class LifecycleMethodsInvoker<T extends LifecycleMethod>
    extends StatefulWidget {
  const LifecycleMethodsInvoker({
    @required this.model,
    this.child,
    this.onLoading,
    Key key,
  })  : assert(model != null),
        super(key: key);

  final T model;
  final Widget onLoading;
  final Widget child;

  @override
  _LifecycleMethodsInvokerState createState() =>
      _LifecycleMethodsInvokerState(model);
}

class _LifecycleMethodsInvokerState extends State<LifecycleMethodsInvoker> {
  _LifecycleMethodsInvokerState(this._model) : _memoizer = AsyncMemoizer();

  AsyncMemoizer<void> _memoizer;
  LifecycleMethod _model;

  void _init() {
    if (_model is Initializable) {
      (_model as Initializable).initialize();
    }
  }

  void _dispose() {
    if (_model is Disposable) {
      (_model as Disposable).dispose();
    }
  }

  @override
  void initState() {
    super.initState();
    _init();
  }

  @override
  void didUpdateWidget(LifecycleMethodsInvoker<LifecycleMethod> oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (oldWidget.model != widget.model) {
      _dispose();
      _model = widget.model;
      _memoizer = AsyncMemoizer();
      _init();
    }
  }

  @override
  Widget build(BuildContext context) {
    return _model is AsyncInitializable
        ? FutureBuilder<void>(
            future: _memoizer
                .runOnce((_model as AsyncInitializable).initializeAsync),
            builder: (ctx, snapshot) {
              return snapshot.connectionState == ConnectionState.done
                  ? widget.child
                  : widget.onLoading;
            })
        : widget.child;
  }

  @override
  void dispose() {
    super.dispose();
    _dispose();
  }
}
